/* Linux zCOM DACS-8200 ʐMTvvO
   LD82DIVC.c    2008/8/8    _bNXZ */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<termios.h>
#include<linux/serial.h>
#include<sys/ioctl.h>
#include<unistd.h>
#include<fcntl.h>

#define BAUDRATE B38400  /* ʐMx̉ݒBۂɓ삷ʐMxł͂Ȃ */
#define MODEMDEVICE "/dev/ttyUSB0" /* foCXt@C̎w */

int main()
{
    int fd;                  /* fd:t@CfBXNv^ */
    int res, txs;            /* res:󂯎 txs:M */
    int recpoint;            /* recpoint:Mf[^i[|Cg */
    long rxtout;             /* rxtout:M^CAEgJE^ */
    int i, j, k;
    struct termios oldtio, newtio;
                             /* ʐM|[g𐧌䂷邽߂̃C^[tFCX */
    struct serial_struct serial;

    char buf[256];           /* Mi[̈ */
    char txtbuf[256];        /* L[͕i[̈ */
    char recbuf[11000];      /* Mf[^i[̈ */

    if((fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY ))==-1){
                             /* O_RDWR:ǂݏp O_NOCTTY:ttyȂ */
        perror(MODEMDEVICE);
        exit(-1);
    }
    tcgetattr(fd, &oldtio);   /* ݂̃VA|[g̐ݒҔ*/
    bzero(&newtio, sizeof(newtio)); /* V|[g̐ݒ̍\̂NA*/
    newtio.c_cflag = (BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD);
    newtio.c_iflag = (IGNPAR | ICRNL);
    newtio.c_oflag = 0;       /* Raw [hł̏o */    
    newtio.c_lflag = 0;       /* JmjJ͂𖳌Ƃ
                              ADϊf[^()100|Cgȏw肷
                              f[^ʂăJmjJł͏łȂ */
    tcflush(fd, TCIFLUSH);
    tcsetattr(fd,TCSANOW,&newtio);

    /* DACS-8200p̃{[[g1382400bpsݒ
       ̑x́ADACS-8200USBpICMPUԂ̃f[^]xƂȂ */
    ioctl(fd,TIOCGSERIAL,&serial);
    serial.custom_divisor = serial.baud_base / 1382400;
    serial.flags = 0x0030;
    ioctl(fd,TIOCSSERIAL,&serial);
    
    do{
        printf("input   > ");
        fgets(txtbuf,32,stdin);  /* L[{[h蕶 */
        if(txtbuf[0] == '-') break; /* - ͂ƏI */
        txs = strlen(txtbuf);
        printf("TX data   > %s",txtbuf);
        txtbuf[txs-1] = 0xd;
        res = read(fd,buf,40);   /* cf[^M(cf[^̔j) */
        write(fd,txtbuf,txs);    /* M */
        recpoint = 0;            /* Mf[^i[|Cg */
        rxtout = 0;              /* M^CAEgJE^Zbg*/
        do{
            res = read(fd,buf,40); /* M */
            if(res != 0){
                for(i = 0; i != res; i++){
                    recbuf[recpoint] = buf[i]; /* Mf[^A */
                    recpoint = recpoint + 1;
                    if(recpoint > 10240) break;
                }
                recbuf[recpoint] = 0;  /* ̏I[Zbg */
                rxtout = 0;            /* M^CAEgJE^Zbg*/
                res = res - 1;
                if((buf[res] == 0xd) || (buf[res] == 0xa)) break;
            }
            else rxtout = rxtout + 1;  /* M^CAEgJE^XV */
        }while(rxtout < 2000000);
        if(recpoint != 0){
            if(recpoint < 41) printf("RX data   > %s",recbuf);
                       /* f[^ȂƂ̎M\ */
            else{      /* ȉ́Af[^SO𒴂Ƃ̕\ */
                j = (recpoint+39)/40;
                for(i = 0; i != j; i++){
                    if((i+1)*40 < recpoint){
                        printf("RX data%3d> ",i);
                        for(k = 0; k != 40; k++){ /* 1sM\ */
                            printf("%c",recbuf[i*40+k]);
                        }
                        printf("\n");
                    }
                    else printf("RX data%3d> %s",i, &recbuf[i*40]);
                }
            }
        }
    }while(1);
    
    tcsetattr(fd, TCSANOW, &oldtio); /* ޔݒɖ߂ */
    close(fd);                       /* |[g */
    return(0);
}
